#!/usr/bin/perl

# vnc_portfw.cgi: Appel de $SLIS_BINDIR/vnc_portfw
# Version 1.0

# This script is part of the SLIS Project initiated by the CARMI-Internet
# (Acadmie de Grenoble - France 38).
# Ce script fait partie du projet SLIS dmarr par le CARMI-Internet
# (Acadmie de Grenoble - France 38).
#
# SLIS : Serveur de communications Linux pour l'Internet Scolaire.
# Copyright (C) 1998-2000 Bruno Bzeznik
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#    You should have received a copy of the GNU General Public License
#    along with this program (For example ./COPYING);
#    if not, write to the Free Software Foundation, Inc., 675 Mass Ave,
#    Cambridge, MA 02139, USA.
#
# Please send all comments and bug reports by electronic mail to:
#   Bruno Bzeznik <Bruno@ac-grenoble.fr>
# or to <slis@ac-grenoble.fr>
#
# Envoyez vos suggestions et reports de bugs par e-mail 
#   Bruno Bzeznik <Bruno@ac-grenoble.fr>
# ou  <slis@ac-grenoble.fr>
#

# Variables
do '/home/hadmin/slis.conf.pl';

$PORTS="/var/spool/vncports";

use CGI ;
$html = new CGI ;
print $html->header ;

# Lecture de l'entete standard HTML
open (HEAD,"$ENTETE");
print <HEAD> ;
close HEAD ;
     
# Recuperation des variables
$vncsvr=$html->param('vncsvr');
$vncport=$html->param('vncport');

# Recherche d'un numero de port disponible entre 8000 et 9000
$extport=8000;
while (`grep -x $extport $PORTS` ne "" && $extport <= 9000) {
  $extport++;
}

# Tests
if ($extport == 9000) {
  print "<H3>Plus de ports disponibles!!<H3>";
  exit 1;
}

if ( $vncsvr !~ /^(\d{0,3})\.(\d{0,3})\.(\d{0,3})\.(\d{0,3})$/ ) {
  print "<COLOR=FF0000><H3>Adresse ip non correcte $vncsvr!</H3></FONT>";
  exit 1;
}

if ( $vncport !~ /^\d{1,5}$/ || $vncport < 5900 || $vncport > 5999 ) {
  print "<COLOR=FF0000><H3>Numero de port non correct $vncport!</H3></FONT>";
  exit 1;
}

# Creation des fichiers dans la file d'attente SLIS
# process_queue prend le relai pour excuter des choses en root
# ($SLIS_BINDIR/vnc_portfw notament)
`echo "$SLIS_BINDIR/vnc_portfw $vncsvr $vncport $extport" >  $QUEUE/vnc_portfw`;
`touch $QUEUE/vnc`;
`touch $QUEUE/tbp`;

# Informations  l'utilisateur et lien vers l'applet vncviewer
print "
<CENTER>
<FONT SIZE=+2 COLOR=#009999><B>
Prise en main d'une station par VNC
</B></FONT>
</CENTER>
<P>
<B>$vncsvr:$vncport &lt;-&gt; $HOSTNAME:$extport</B><P>
<I><FONT COLOR=00AA00>Vous venez d'ouvrir une session permettant de
traverser le SLIS pour administrer une station de l'intranet. La session
sera ouverte pendant 30 minutes. Un port du SLIS a
&eacute;t&eacute; affect&eacute; pour correspondre au serveur VNC de la
station sp&eacute;cifi&eacute;e.</FONT><P>
Pour prendre en main $vncsvr, vous avez 2 possibilit&eacute;s:
<UL>
<LI> Utiliser le <A HREF=vncviewer.cgi?port=$extport> client JAVA
int&eacute;gr&eacute; &agrave; l'interface SLIS en cliquant sur ce
lien</A>
<LI> Utiliser un client VNC externe. Vous devrez sp&eacute;cifier l'hote
<B>$HOSTNAME</B> et le port <B>$extport</B>.
</UL>
";

# Lecture du pied de page standard
open (FOOT,"$PIED");
print <FOOT> ;
close FOOT ;
